	parameter(nelmax=16,nz=30)
	character*2, dimension(nz) :: elnam
	data elnam/'h ','he','li','be','b ','c ','n ','o ','f ','ne', &
	           'na','mg','al','si','p ','s ','cl','ar','k ','ca', &
		   'sc','ti','v ','cr','mn','fe','co','ni','cu','zn'/
	real z(nelmax),f(nelmax)
	real frac(nz)
	character*64 fnam
	character*2 shell,element
	character*128 s
	open(unit=10,file='index',status='old')
	nmol = 0
	do while (.true.)
	  read (10,'(a)',end=3) s
	  if (len_trim(s(1:4)).gt.0) nmol = nmol + 1
	enddo
3	close(10)
	imol = 0
	open(unit=10,file='index',status='old')
	open(unit=11,file='molcomp.dat',status='replace')
	write (11,'(i4)') nmol
	iedge = 1 ; nedge = 1
	k = 0
	do while (.true.)
	  read (10,'(a)',end=1) s
	  read (s(8:35),'(a)') fnam
	  ls    = len_trim(fnam)
	  idot2 = scan(fnam(1:ls),".",.true.)
	  idot1 = scan(fnam(1:idot2-1),".",.true.)
	  shell = fnam(idot2+1:ls)
	  element = fnam(idot1+1:idot2-1)   !element number
	  do iz = 1,nz
	    if (trim(element).eq.trim(elnam(iz))) exit
	  enddo
	  if (iz.gt.nz) then
	    write (*,*) 'error in element name at line ',k+1
	    stop 'error'
	  endif
	  izshell = iz
	  isshell = 0
	  if (trim(shell).eq.'1s')    isshell = 1
	  if (trim(shell).eq.'2s')    isshell = 2
	  if (trim(shell).eq.'2p')    isshell = 3
	  if (trim(shell).eq.'3s')    isshell = 5
	  if (trim(shell).eq.'3p')    isshell = 6
	  if (trim(shell).eq.'3d')    isshell = 8
	  if (trim(shell).eq.'4s')    isshell = 10
	  if (isshell.eq.0) then
	    write (*,*) 'error in shell name at line ',k+1
	    stop 'error'
	  endif
	  if (len_trim(s(1:4)).gt.0) then    !first edge of this molecule
	    if (iedge.ne.nedge) then   !error message for previous molecule
	      write (*,*) 'Serious error: your last molecule should have ',nedge,' edges'
	      write (*,*) 'However, we found only ',iedge,' edges'
	      write (*,*) 'check index at line ',k
	      stop 'error'
	    endif
	    read (s(1:6),*) number,nedge
	    read (s(37:),*) nel
	    read (s(37:),*) neldum,(z(i),f(i),i=1,nel)
	    frac = 0.
	    do i = 1,nel
	      iz = nint(z(i))
	      frac(iz) = f(i)
	    enddo
	    iedge = 1
	    imol  = imol + 1
	  else                        !continuation edge
	    iedge = iedge + 1
	    if (iedge.gt.nedge) then
	      write (*,*) 'there are more edges then prescribed. Check index file at line',k
	      stop 'error'
	    endif
	  endif
	  k = k + 1
	  if (iedge.eq.1) then
	    write (11,'(i4,1x,i4)') k,nedge
	    write (11,'(a)') trim(fnam(1:idot1-1))
	    write (11,'(i4,30f7.3)') number,frac
	  endif
	  open(unit=20,file=trim(fnam),status='old')
	  read (20,'(a)') s
	  read (20,*) e1,f1
	  ne = 1
	  do while (.true.)
	    read (20,*,end=2) x,y
	    e2 = x
	    ne = ne + 1
	  enddo
2	  close(20)
	  de = (e2 - e1) / float(ne - 1)

	  write (11,'(i2,1x,i2,i5,1x,f6.1,1x,f6.1)') izshell,isshell,ne,e1,e2
	  open(unit=20,file=trim(fnam),status='old')
	  read (20,'(a)') s
	  do i = 1,ne
	    read (20,*) x,y
	    write (11,'(f8.5)') y
	  enddo
	  close(20)
	enddo
1	close(10)
	close(11)
	if (imol.ne.nmol) then
	  write (*,'(" Error: mismatch in numer of molecules; check carefully!")')
	endif
	end
	 
