	character*128 fnam,s,gnam
	parameter(m=10000)
	real e(m),f(m)
	open(unit=9,file='scale.dat',status='old')
	do nf = 1,100000
	  read (9,'(a)',end=100) fnam             !input file
	  write (gnam,'("../",a)') trim(fnam)     !output file
!-- type of edge
	  if (nf.le.12) then
	    it = 1   !Si 1s
	  else if (nf.le.18) then
	    it = 2   !Fe 1s
	  else
	    it = 3   !Fe 2s
	  endif
	  open(unit=10,file=trim(fnam),status='old')
	  open(unit=11,file=trim(gnam),status='replace')
	    read (10,'(a)') s
	    s(1:1) = "!"   !overrule #
	    write (11,'(a)') trim(s)
	    do i = 1,100000
	      read (10,*,end=1) e(i),f(i)
	    enddo
1	  close(10)
	  n = i - 1
!-- sanity check
	  do i = 2,n
	    if (e(i).le.e(i-1)) then
	      write (*,*) 'error in order at line',i
	      write (*,'(a)')fnam
	      stop
	    endif
	  enddo
	  emin = minval(e(1:n))
	  emax = maxval(e(1:n))
	  select case (it)
	    case (1) ; de = 0.2 ; e1 = 1830 ; e2 = 1880 ; e3 = 1890 ; s1 = 14.67e-3 ; s2=13.66e-3 ; g2 = 0.1303 ; g3 = 0.1288
	    case (2) ; de = 1.0 ; e1 = 7050 ; e2 = 7300 ; e3 = 7320 ; s1 = 4.89e-3 ; s2 = 3.42e-3 ; g2 = 3.1656e-2
	    case (3) ; de = 0.2 ; e2 = 750  ;  e3 = 750
	  end select
	  emax = max(emax,e3) * (1.+10.*epsilon(e3))
	  emin = de * ceiling(emin / de)
	  emax = de * floor(emax / de)
	  ne   = nint((emax - emin) / de + 1.)
	  write (*,*) emin,emax,de,trim(fnam)
	  do i = 1,n
	    fother = (e(i) - e1) / (e2 - e1) * (s2 - s1) + s1   !linear interpolation higher shell contribution atomic
	    fatom  = (e(i) - e2) / (e3 - e2) * (g3 - g2) + g2   !linear interpolation relevant shell atomic
	    if (it.eq.2) then
	      fatom = 3.1656e-2 * (7300./e(i))**2.5421
	      f(i) = f(i) * fatom
	      fother = 0.
	    endif
	    ratio = 1.
	    if (it.eq.3) then
	      fother = 0.1885
	      fatom  = 1.407-0.1885    !1.173 spex
	      ratio  = 1.173 / (f(n)-fother)   !1.173 /  1.219
	    endif
!	    write (13,*) e(i),f(i),f(i)-fother,fother
	    f(i) = (f(i) - fother) * ratio
	  enddo
	  do i = 1,ne
	    ee = emin + (i-1) * de
	    if (ee.le.e2) then
	      call hunt(e,n,ee,jlo)
	      jlo = max(1,jlo)
	      jlo = min(n-1,jlo)
	      call polint(e(jlo),f(jlo),2,ee,yy,dyy)
	      if (abs(ee - e2).lt.1.e-3) then
	        yy2 = yy
		rat = yy / g2 - 1.
	      endif
	      if (it.eq.3.and.ee.gt.e(n)) yy = f(n)
	    else
	      fatom  = (ee - e2) / (e3 - e2) * (g3 - g2) + g2   !linear interpolation relevant shell atomic
	      if (it.eq.2) fatom = 3.1656e-2 * (7300./ee)**2.5421
	      yy = fatom * (1. + rat * (e3 - ee) / (e3 - e2))
	    endif
	    yy = max(yy,0.)
	    if (i.eq.1) yy = 0.
	    write (11,'(f6.1,f8.5)') ee,yy
	    write (12,'(f6.1,f8.5)') ee,yy
	      
	  enddo
	  write (12,*) 'no'
!	  if (nf.eq.19) stop
	enddo
100	close(9)
	end
