	parameter(nx=91,ncol=10,nionmax=176,nzu=13,nz=30,nz1=nz+1)
	real, dimension(:), allocatable :: xil,hcol
	real, dimension(:,:), allocatable :: ra,ta
	real, dimension(:,:,:,:), allocatable :: con
	
	integer izu(nzu),index(nz1,nz)
	data izu/1,2,6,7,8,10,12,14,16,18,20,26,28/
	real, dimension(nzu) :: abun
	data abun/1.,0.1,3.54e-4,9.33e-5,7.41e-4,1.20e-4,3.8e-5,3.55e-5, &
	  2.14e-5,3.31e-6,2.29e-6,3.16e-5,1.78e-6/
	real, dimension(nz) :: agr = (/ &
       12.00,10.99, 1.16, 1.15, 2.6 , 8.56, 8.05, 8.93, 4.56, 8.09, &
        6.33, 7.58, 6.47, 7.55, 5.45, 7.21, 5.5 , 6.56, 5.12, 6.36, &
        3.10, 4.99, 4.00, 5.67, 5.39, 7.67, 4.92, 6.25, 4.21, 4.60/)
	
	real conz(nz1),conji(nz1,nz)
	real, dimension(:,:,:), allocatable :: conjix
	character*80 fnam
	
	allocate(con(3,nionmax,ncol,nx),ra(ncol,nx),ta(ncol,nx),xil(nx),hcol(nx))
	call read_data(con,ra,ta,ncol,nx,xil,hcol)
	
	index = 0
	in    = 8
	do i = 1,nzu
	  do jz = 1,izu(i)
	    in = in + 1
	    index(jz,izu(i)) = in
	  enddo
	enddo
	
!-- output
	
	do i = 1,nzu
	  icol = 1
	  write (fnam,'("column",i2.2,".dat")') izu(i)
	  write (*,*) trim(fnam)
	  open(unit=21,file=trim(fnam),status='replace')
	  write (21,'("! xi",29i5)') (/ (k,k=1,izu(i)+1) /)
	  if (i.eq.1) open(unit=22,file='taver.dat',status='replace')
	  do ix = 1,nx
	    bare = 0.
	    do jz = 1,izu(i)
	      in       = index(jz,izu(i))
	      conz(jz) = alog10(max(1.,con(1,in,icol,ix) * hcol(icol) * abun(i))) - 22.00 + 10.00
	      bare     = bare + con(1,in,icol,ix)
	    enddo
	    bare = 1. - bare
	    if (bare.lt.1.e-4) bare = 0.
	    conz(izu(i)+1) = alog10(max(1.,bare * hcol(icol) * abun(i))) - 22.00 + 10.00
	    conz = max(conz,0.)
	    if (i.eq.1) write (21,'(f4.1,2f6.2)') xil(ix),(conz(jz),jz=1,izu(i)+1)
	    if (i.ne.1) write (21,'(f4.1,29f5.2)') xil(ix),(conz(jz),jz=1,izu(i)+1)
	    if (i.eq.1) write (22,'(f4.1,2f8.2)') xil(ix),ta(1,ix),alog10(0.961*10.**xil(ix)/ta(1,ix))
	  enddo
	  close(21)
	  if (i.eq.1) close(22)
	enddo
	
!-- make file for input in spex model

	open(unit=21,file='xstarrun.dat',status='replace')
	allocate(conjix(nx,nz+1,nz))
	do ix = 1,nx
	  write (21,'(f4.1,f8.3)') xil(ix),ta(1,ix)*0.8617385   !in eV
	enddo
	do ix = 1,nx
	  icol  = 1
	  conji = 0.
	  do i = 1,nzu
	    bare = 0.
	    do jz = 1,izu(i)
	      in               = index(jz,izu(i))
	      conji(jz,izu(i)) = con(1,in,icol,ix)
	      bare             = bare + con(1,in,icol,ix)
	    enddo
	    bare = 1. - bare
	    if (bare.lt.1.e-4) bare = 0.
	    conji(izu(i)+1,izu(i)) = bare
	  enddo
	  conji = alog10(max(1.e-12,conji))
!-- interpolate missing element Na & Al
	  do iz = 11,13,2
	  izne = iz - 1 ; izmg = iz + 1
	  do jz = 1,iz+1
	    ii   = iz - jz + 1     !isoelectronic sequence
	    if (ix.le.50) then         !low ionisation, interpolate in stage
	      if (jz.le.iz) then
	        clne = conji(jz,izne)
	        clmg = conji(jz,izmg)
	        conji(jz,iz) = (clne * (izmg - iz) + clmg * (iz - izne)) / float(izmg - izne)
	      else
	        conji(jz,iz) = -12.
	      endif
	    else                       !high ionisation, interpolate along isoelectronic sequence
	      jzne = izne - ii + 1
	      jzmg = izmg - ii + 1
	      if (jz.gt.1) then
	        clne  = conji(jzne,izne)
	        clmg  = conji(jzmg,izmg)
	        conji(jz,iz) = (clne * (izmg - iz) + clmg * (iz - izne)) / float(izmg - izne)
	      else
	        conji(jz,iz) = -12.
	      endif
	    endif
	  enddo
	  bion = 0.
	  do jz = 1,iz+1
	    bion = bion + 10.**conji(jz,iz)
	  enddo
	  do jz = 1,iz+1
	    conji(jz,iz) = alog10(max(1.e-12,10.**conji(jz,iz) / bion))
	  enddo
	  enddo
!-- scale to column of 1E28 and correct for abundances (here Anders & Grevesse!)
	  do iz = 1,nz
	    do jz = 1,iz+1
	      if (conji(jz,iz).gt.-7.0) then
	        conjix(ix,jz,iz) = (agr(iz) - 12.) + 28. + conji(jz,iz)
	      else
	        conjix(ix,jz,iz) = -9.
	      endif
	    enddo
	  enddo
	enddo
	nuse = 0
	do iz = 1,nz
	  if (iz.gt.2.and.iz.lt.6) cycle
	  if (iz.eq.9.or.iz.eq.15.or.iz.eq.17.or.iz.eq.27) cycle
	  if (iz.gt.18.and.iz.lt.26) cycle
	  if (iz.gt.28) cycle
	  do jz = 1,iz+1
	    nuse = nuse + 1
	    write (21,'(i2,i3)') iz,jz
	    do ix = 1,nx
	      write (21,'(f5.2)') conjix(ix,jz,iz)
	    enddo
	  enddo
	enddo
	close(21)
	write (*,*) 'nuse = ',nuse
	stop
	
!-- determine log column densities in con(1,...)

	do ix = 1,nx
	  do icol = 1,ncol
	    do i = 1,nzu
	      do jz = 1,izu(i)
	        in = index(jz,izu(i))
	        con(1,in,icol,ix) = alog10(max(1.,con(1,in,icol,ix) * hcol(1) * abun(i)))
	      enddo
	    enddo
	  enddo
	enddo
	
	insi = index(14,14)
	inmg = index(12,12)
	ino6 = index(6,8)
	inc6 = index(6,6)
	inc4 = index(4,6)
	inn5 = index(5,7)
	inh1 = index(1,1)
	
	do ix = 1,nx
	  c = 0.  !con(1,ino6,1,ix)
	  write (20,'(f4.2,6f7.2)') xil(ix),con(1,inh1,1,ix)-c,con(1,inc4,1,ix)-c,con(1,inc6,1,ix)-c, &
	                         con(1,inn5,1,ix)-c,con(1,inmg,1,ix)-c,con(1,insi,1,ix)-c
	enddo
	      
	
	in = index(8,8)
	do ix = 1,nx
	  write (10,'(f4.2,10(1pe11.3))') xil(ix),(con(1,in,icol,ix),icol=1,ncol)
	  write (11,'(f4.2,10(1pe11.3))') xil(ix),(con(2,in,icol,ix),icol=1,ncol)
	  write (12,'(f4.2,10(1pe11.3))') xil(ix),(ta(icol,ix)*con(3,in,icol,ix),icol=1,ncol)
	enddo
	
	end
	
	subroutine read_data(conc,ra,ta,ncol,nxi,xil,hcol)
	
	parameter(nrmax=512,ncolmax=176)
	real conc(3,ncolmax,ncol,nxi),ra(ncol,nxi),ta(ncol,nxi),xil(nxi),hcol(ncol)
	integer, parameter :: neps = 100
	character*256 fnam
	real, dimension(:,:), allocatable :: con
	real, dimension(:), allocatable :: t,r,s_con,s_rcon,s_tcon
	
	allocate(con(nrmax,ncolmax),t(nrmax),r(nrmax))
	allocate(s_con(ncolmax),s_rcon(ncolmax),s_tcon(ncolmax))
	do ilw = 10,100
	  il   = ilw - 9
	  ixil = ilw - 50
	  xil(il) = 0.1 * float(ixil)
	  do icol = 0,0!9
	    hcol(icol+1) = 1.E22   !in SI
	    write (fnam,'("/home/kaastra/work/02/5548/xstar/xi",i3.3,"/xout_abund1.fits")') ilw
	    ier = 0	
	    call read_model(trim(fnam),r,t,con,nr,nrmax,ier)
	    write (*,'(a,i4,i3,i2,i5)') trim(fnam),ilw,icol,ier,nr
	    if (ier.ne.0) cycle
	    s_con = 0. ; s_rcon = 0. ; s_tcon = 0.
	    s_t = 0.
	    do ir = 2,nr
	      dr = (r(ir)-r(ir-1)) / float(neps)
	      dt = (t(ir)-t(ir-1)) / float(neps)
	      do ieps = 1,neps
	        rr = r(ir-1) + dr * (ieps-0.5)
	        tt = t(ir-1) + dt * (ieps-0.5)
	        do ic = 9,ncolmax
	          co = con(ir-1,ic) + (con(ir,ic)-con(ir-1,ic))*(ieps-0.5)/float(neps)
	          s_con(ic)  = s_con(ic)  + co * dr
	          s_rcon(ic) = s_rcon(ic) + co * dr * rr
	          s_tcon(ic) = s_tcon(ic) + co * dr * tt 
	        enddo
	        s_t = s_t + tt * dr
	      enddo
	    enddo
	    taver  = s_t / r(nr)
	    s_con  = s_con / r(nr)
	    s_rcon = s_rcon / r(nr)
	    s_tcon = s_tcon / r(nr)
	    do ic = 9,ncolmax
	      if (s_con(ic).le.0.) cycle
	      s_rcon(ic) = s_rcon(ic) / s_con(ic) / r(nr)
	      s_tcon(ic) = s_tcon(ic) / s_con(ic) / taver
	    enddo
	    do ic = 1,ncolmax
	      conc(1,ic,icol+1,il) = s_con(ic)
	      conc(2,ic,icol+1,il) = s_rcon(ic)
	      conc(3,ic,icol+1,il) = s_tcon(ic)
	    enddo
	    ta(icol+1,il) = taver
	    ra(icol+1,il) = r(nr)
	  enddo
	enddo
	deallocate(s_con,s_rcon,s_tcon,t,r,con)
	end
	
		subroutine read_model(fnam,r,t,con,nr,nrmax,ier)
	
	implicit none
	
	character*(*), intent(in) :: fnam
	integer, intent(in) :: nrmax
	integer, intent(out) :: nr
	integer, intent(out) :: ier
	real, dimension(nrmax), intent(out) :: r      !radii
	real, dimension(nrmax), intent(out) :: t      !t4
	real, dimension(nrmax,128), intent(out) :: con    !average concentration of each ion
	
	integer, parameter :: maxdim=148
	character*80 extname
	character*16, dimension(maxdim) :: ttype,tunit
	character*8, dimension(maxdim) :: tform
	integer l,colnum,iel,ir,ix,ixi,unit,status,blocksize, &
	  hdutype,rowlen,tfields,nrows,lu,i,i1,jz
	integer, dimension(maxdim) :: tbcol
	logical anyf

!-- columns:
! 1 - radius    cm
! 2 - delta_r   cm
! 3 - ion_parameter  erg*cm/s
! 4 - x_e
! 5 - n_p     cm**-3
! 6 - pressure dynes/cm**2	
! 7 - temperature (1E4 K)
! 8 heat_error
! 9 H I etc.

	  status = 0
	  unit = 50
	  call ftopen(unit,trim(fnam),0,blocksize,status)
	  ier = 0
	  if (status.ne.0) then
	    call ftclos(unit,status)
	    ier = 1
	    con = 0.
	    t   = 0.
	    r   = 0.
	    return
	  endif
	    
	  call ftmahd(unit,2,hdutype,status)
	  call ftghtb(unit,maxdim,rowlen,nrows,tfields,ttype,tbcol,tform,tunit,extname,status)
	  nr = nrows
	  do colnum = 1,tfields
	    call ftgcve(unit,colnum,1,1,nrows,0.,con(1:nrows,colnum),anyf,status)
	  enddo
	  t = con(:,7)
	  r = con(:,2)
	    
	  call ftclos(unit,status)
	end
	
