! nitrogen: 395 - 430 eV =  11 - 281 pix
! bottoms at ypix = 577, 463, 349, 235, 121 pix
! E = 395 + 35. * (ix - 11) / 270.
! y = (577 - iy) - 114 * j  for j = 0 to 4 from bottom to top
! 291 x 592 array
!
! oxygen: 525 - 555 eV = 14 - 285 pix
! bottoms at 583, 469, 355, 241, ... pix
! E = 525 + 30. * (ix - 14) / 271.
! y = (583 - iy) - 114 * j for j = 0 to 4 pix
! 293 x 601 array
!
! DNA nitrogen: 395 - 430 = 20 - 266.5 pix 
! bottom axis @ 220
! E = 395 + 35. * (ix - 20) / 264.5

! DNA oxygen: 525 - 555 eV = 18 - 268 pix
! bottom axis @ 476, lowest at 474
! E = 525 + 30. * (ix - 18) / 250.
! 289 x 490 array

! Note: near the edge, the N-K cross-section in Mbarn is 2.077E5/E**2.1062
! with E in eV
! 1s-  2.077E5/E**2.1062
! 2s-  4.814E4/E**2.3816    ~  cross-section is 20 x smaller
! 2p1/2 6.288E6/E**3.5153
! 2p3/2 3.147E6/E**3.5154

	parameter(nm=700,mm=500)
	integer, dimension(mm,nm) :: pix
	real x(1000),y(1000)

!-- nitrogen

	open(unit=10,file='n1_t0.txt',status='old')
	open(unit=14,file='n.qdp',status='replace')
	m = 291
	n = 592
	do i = n,1,-1
	  read (10,'(1024i1)') (pix(j,i),j=1,m)
	  iy = i
	  f = 577 - iy
	  do j = 1,m
	    if (pix(j,i).eq.1) then
	      e = 395 + 35. * (j - 11) / 270.
!	      write (11,'(f6.2,1x,i4)') e,nint(f)
	    endif
	  enddo 
	enddo
	do k = 1,5
	  ik = 0
	  do j = 1,m
	    s  = 0.
	    ns = 0
	    e  = 395 + 35. * (j - 11) / 270.
	    do i = 1,n
	      if (pix(j,i).eq.1) then
	        f = 577 - i - 114 * (k - 1)
		if (f.lt.-10.0.and.e.lt.405.0) cycle
		if (f.lt.-10.0.and.e.gt.410.0) cycle
		if (f.lt.10.0.and.e.ge.405.0.and.e.le.410.0) cycle
		if (f.gt.117.0.and.e.gt.400.0) cycle
		if (k.le.4.and.e.le.400.and.f.gt.100) cycle
		if (k.eq.5.and.e.le.400.and.f.gt.150.) cycle
!		write (13,*) e,f
	        ns = ns + 1
		s  = s + f
	      endif
	    enddo
	    if (ns.gt.0) then
	      s = s / ns
	      ik = ik + 1
	      x(ik) = e
	      y(ik) = s
!	      write (12,'(f6.2,f6.1)') e,s
	    endif
	  enddo
	  nk = ik
	  xmin = minval(x(1:nk))
	  xmax = maxval(x(1:nk))
	  xmin  = ceiling(xmin * 10.) / 10.0
	  xmax  = floor(xmax * 10.) / 10.0
	  ymin  = minval(y(1:nk))
	  do i = 1,nk
	    y(i) = y(i) - ymin
	  enddo
	  do ix = nk,1,-1
	    if (y(ix).eq.0.) exit
	  enddo
	  write (*,*) 'ix = ',ix
	  do jx = 1,ix
	    y(jx) = 0.
	  enddo
	  xx = xmax
	  call hunt(x,nk,xx,jlo)
	  call polint(x(jlo),y(jlo),2,xx,yy,dyy)
	  s1 = 2.077E5/xx**2.1062
	  s2 = 4.814E4/xx**2.3816 
          s3 = 6.288E6/xx**3.5153
          s4 = 3.147E6/xx**3.5154
	  ss = s1 + s2 + s3 + s4
	  tt = yy / ss
	  do ix = nint(xmin*10.),nint(xmax*10.)
	    xx = float(ix) / 10.
	    call hunt(x,nk,xx,jlo)
	    call polint(x(jlo),y(jlo),2,xx,yy,dyy)
	    s1 = 2.077E5/xx**2.1062
	    s2 = 4.814E4/xx**2.3816 
            s3 = 6.288E6/xx**3.5153
            s4 = 3.147E6/xx**3.5154
	    ss = s1 + s2 + s3 + s4
	    write (14,'(f5.1,1x,f8.4)') xx,yy/tt
	  enddo
!	  write (12,'("NO")')
!	  write (13,'("NO")')
	  write (14,'("NO")')
	enddo
	close(10)
	close(14)

!-- oxygen

	open(unit=10,file='o2_t0.txt',status='old')
	open(unit=14,file='o.qdp',status='replace')
	m = 293
	n = 601
	do i = n,1,-1
	  read (10,'(1024i1)') (pix(j,i),j=1,m)
	  iy = i
	  f = 583 - iy
	  do j = 1,m
	    if (pix(j,i).eq.1) then
	      e = 525 + 30. * (j - 18) / 250.
!	      write (11,'(f6.2,1x,i4)') e,nint(f)
	    endif
	  enddo 
	enddo
	do k = 1,5
	  ik = 0
	  do j = 1,m
	    s  = 0.
	    ns = 0
	    e  = 525 + 30. * (j - 18) / 250.
	    do i = 1,n
	      if (pix(j,i).eq.1) then
	        f = 583 - i - 114 * (k - 1)
		if (f.lt.-5.or.f.gt.117.) cycle
		if (e.gt.537.and.e.lt.542.and.f.lt.10.) cycle
		if (e.gt.530.9.and.e.lt.532.and.f.lt.5.) cycle
		if (k.le.2.and.f.gt.110.and.e.lt.535) cycle
		if (k.eq.3.and.f.gt.110.and.e.lt.531) cycle
!		write (13,*) e,f
	        ns = ns + 1
		s  = s + f
	      endif
	    enddo
	    if (ns.gt.0) then
	      s = s / ns
	      ik = ik + 1
	      x(ik) = e
	      y(ik) = s
!	      write (12,'(f6.2,f6.1)') e,s
	    endif
	  enddo
	  nk = ik
	  xmin = minval(x(1:nk))
	  xmax = maxval(x(1:nk))
	  xmin  = ceiling(xmin * 10.) / 10.0
	  xmax  = floor(xmax * 10.) / 10.0
	  ymin  = minval(y(1:nk))
	  do i = 1,nk
	    y(i) = y(i) - ymin
	  enddo
	  do ix = nk,1,-1
	    if (y(ix).eq.0.) exit
	  enddo
	  do jx = 1,ix
	    y(jx) = 0.
	  enddo
	  xx = xmax
	  call hunt(x,nk,xx,jlo)
	  call polint(x(jlo),y(jlo),2,xx,yy,dyy)
	  s1 = 1.950E5/xx**2.0482
	  s2 = 7.701E4/xx**2.3919 
          s3 = 1.684E7/xx**3.5488
          s4 = s3                
	  ss = s1 + s2 + s3 + s4
	  tt = yy / ss
	  do ix = nint(xmin*10.),nint(xmax*10.)
	    xx = float(ix) / 10.
	    call hunt(x,nk,xx,jlo)
	    call polint(x(jlo),y(jlo),2,xx,yy,dyy)
	    s1 = 1.950E5/xx**2.0482
	    s2 = 7.701E4/xx**2.3919 
            s3 = 1.684E7/xx**3.5488
            s4 = s3
	    ss = s1 + s2 + s3 + s4
	    write (14,'(f5.1,1x,f8.4)') xx,yy/tt
	  enddo
!	  write (12,'("NO")')
!	  write (13,'("NO")')
	  write (14,'("NO")')
	enddo
	close(10)
	close(14)
	
!-- dna N

	open(unit=10,file='dna2_t0.txt',status='old')
	open(unit=14,file='dna_n.qdp',status='replace')
	m = 289
	n = 490
	do i = n,1,-1
	  read (10,'(1024i1)') (pix(j,i),j=1,m)
	  iy = i
	  f = 220 - iy
	  do j = 1,m
	    if (pix(j,i).eq.1) then
	      e = 395 + 35. * (j - 20) / 264.5
!	      write (11,'(f6.2,1x,i4)') e,nint(f)
	    endif
	  enddo 
	enddo
	do k = 1,1
	  ik = 0
	  do j = 1,m
	    s  = 0.
	    ns = 0
	    e  = 395 + 35. * (j - 20) / 264.5
	    do i = 1,n
	      if (pix(j,i).eq.1) then
	        f = 220 - i
		if (f.lt.0.) cycle
!		write (13,*) e,f
	        ns = ns + 1
		s  = s + f
	      endif
	    enddo
	    if (ns.gt.0) then
	      s = s / ns
	      ik = ik + 1
	      x(ik) = e
	      y(ik) = s
!	      write (12,'(f6.2,f6.1)') e,s
	    endif
	  enddo
	  nk = ik
	  xmin = minval(x(1:nk))
	  xmax = maxval(x(1:nk))
	  xmin  = ceiling(xmin * 10.) / 10.0
	  xmax  = floor(xmax * 10.) / 10.0
	  ymin  = minval(y(1:nk))
	  do i = 1,nk
	    y(i) = y(i) - ymin
	  enddo
	  do ix = nk,1,-1
	    if (y(ix).eq.0.) exit
	  enddo
	  do jx = 1,ix
	    y(jx) = 0.
	  enddo
	  xx = xmax
	  call hunt(x,nk,xx,jlo)
	  call polint(x(jlo),y(jlo),2,xx,yy,dyy)
	  s1 = 2.077E5/xx**2.1062
	  s2 = 4.814E4/xx**2.3816 
          s3 = 6.288E6/xx**3.5153
          s4 = 3.147E6/xx**3.5154
	  ss = s1 + s2 + s3 + s4
	  tt = yy / ss
	  do ix = nint(xmin*10.),nint(xmax*10.)
	    xx = float(ix) / 10.
	    call hunt(x,nk,xx,jlo)
	    call polint(x(jlo),y(jlo),2,xx,yy,dyy)
	    s1 = 2.077E5/xx**2.1062
	    s2 = 4.814E4/xx**2.3816 
            s3 = 6.288E6/xx**3.5153
            s4 = 3.147E6/xx**3.5154
	    ss = s1 + s2 + s3 + s4
	    write (14,'(f5.1,1x,f8.4)') xx,yy/tt
	  enddo
!	  write (12,'("NO")')
!	  write (13,'("NO")')
	  write (14,'("NO")')
	enddo
	close(10)
	close(14)
	
!-- dna O

	open(unit=10,file='dna2_t0.txt',status='old')
	open(unit=14,file='dna_o.qdp',status='replace')
	m = 289
	n = 490
	do i = n,1,-1
	  read (10,'(1024i1)') (pix(j,i),j=1,m)
	  iy = i
	  f = 474 - iy
	  do j = 1,m
	    if (pix(j,i).eq.1) then
	      e = 525 + 30. * (j - 18) / 250.
	      write (11,'(f6.2,1x,i4)') e,nint(f)
	    endif
	  enddo 
	enddo
	do k = 1,1
	  ik = 0
	  do j = 1,m
	    s  = 0.
	    ns = 0
	    e  = 525 + 30. * (j - 18) / 250.
	    do i = 1,n
	      if (pix(j,i).eq.1) then
	        f = 474 - i
		if (f.gt.250.) cycle
		write (13,*) e,f
	        ns = ns + 1
		s  = s + f
	      endif
	    enddo
	    if (ns.gt.0) then
	      s = s / ns
	      ik = ik + 1
	      x(ik) = e
	      y(ik) = s
	      write (12,'(f6.2,f6.1)') e,s
	    endif
	  enddo
	  nk = ik
	  xmin = minval(x(1:nk))
	  xmax = maxval(x(1:nk))
	  xmin  = ceiling(xmin * 10.) / 10.0
	  xmax  = floor(xmax * 10.) / 10.0
	  ymin  = minval(y(1:nk))
	  do i = 1,nk
	    y(i) = y(i) - ymin
	  enddo
	  do ix = nk,1,-1
	    if (y(ix).eq.0.) exit
	  enddo
	  do jx = 1,ix
	    y(jx) = 0.
	  enddo
	  xx = xmax
	  call hunt(x,nk,xx,jlo)
	  call polint(x(jlo),y(jlo),2,xx,yy,dyy)
	  s1 = 2.077E5/xx**2.1062
	  s2 = 4.814E4/xx**2.3816 
          s3 = 6.288E6/xx**3.5153
          s4 = 3.147E6/xx**3.5154
	  ss = s1 + s2 + s3 + s4
	  tt = yy / ss
	  do ix = nint(xmin*10.),nint(xmax*10.)
	    xx = float(ix) / 10.
	    call hunt(x,nk,xx,jlo)
	    call polint(x(jlo),y(jlo),2,xx,yy,dyy)
	    s1 = 2.077E5/xx**2.1062
	    s2 = 4.814E4/xx**2.3816 
            s3 = 6.288E6/xx**3.5153
            s4 = 3.147E6/xx**3.5154
	    ss = s1 + s2 + s3 + s4
	    write (14,'(f5.1,1x,f8.4)') xx,yy/tt
	  enddo
	  write (12,'("NO")')
	  write (13,'("NO")')
	  write (14,'("NO")')
	enddo
	close(10)
	close(14)
	
	end
	  
	  
